"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DFViewerEx = exports.DFViewer = void 0;
const react_1 = __importStar(require("react"));
const lodash_1 = __importDefault(require("lodash"));
const gridUtils_1 = require("./gridUtils");
const utils_1 = require("../utils");
const ag_grid_react_1 = require("ag-grid-react"); // the AG Grid React Component
const staticData_1 = require("../../baked_data/staticData");
const gridUtils_2 = require("./gridUtils");
function DFViewer({ df_data: df, df_viewer_config, summary_stats_data, style, activeCol, setActiveCol, }) {
    var _a, _b;
    /* = {
      df: EmptyDf.data,
      df_viewer_config: EmptyDf.dfviewer_config,
      summary_stats_data: [],
      style: { height: '300px' },
      setActiveCol: () => null,
    }*/
    //console.log("dfviewer df_viewer_config", df_viewer_config);
    //  console.log("summary_stats_data", summary_stats_data);
    //  console.log("full_object", {'df':df, 'df_viewer_config':df_viewer_config, 'summary_stats_data': summary_stats_data})
    const [agColsPure, agData] = (0, gridUtils_1.dfToAgrid)(df, df_viewer_config, summary_stats_data || []);
    const styledColumns = (0, utils_1.replaceAtMatch)(lodash_1.default.clone(agColsPure), activeCol || '___never', {
        cellStyle: { background: 'var(--ag-range-selection-background-color-3)' },
    });
    const defaultColDef = {
        sortable: true,
        type: 'rightAligned',
        cellRendererSelector: (0, gridUtils_2.getCellRendererSelector)(df_viewer_config.pinned_rows),
    };
    const gridOptions = Object.assign({ rowSelection: 'single', onRowClicked: (event) => console.log('A row was clicked'), tooltipShowDelay: 0, 
        // defaultColDef needs to be specifically passed in as a prop to the component, not defined here,
        // otherwise updates aren't reactive
        onCellClicked: (event) => {
            const colName = event.column.getColId();
            if (setActiveCol === undefined || colName === undefined) {
                return;
            }
            else {
                setActiveCol(colName);
            }
        } }, (df_viewer_config.extra_grid_config
        ? df_viewer_config.extra_grid_config
        : {}));
    const gridRef = (0, react_1.useRef)(null);
    const pinned_rows = df_viewer_config.pinned_rows;
    const topRowData = summary_stats_data
        ? (0, gridUtils_1.extractPinnedRows)(summary_stats_data, pinned_rows ? pinned_rows : [])
        : [];
    const getAutoSize = () => {
        console.log('getAutoSize');
        if (styledColumns.length < 1) {
            return {
                type: 'fitProvidedWidth',
                width: window.innerWidth - 100,
            };
        }
        return {
            type: 'fitCellContents',
        };
    };
    const dfvHeight = window.innerHeight /
        (((_a = df_viewer_config === null || df_viewer_config === void 0 ? void 0 : df_viewer_config.component_config) === null || _a === void 0 ? void 0 : _a.height_fraction) || 2);
    const regularDivStyle = {
        height: dfvHeight,
    };
    const shortDivStyle = {
        minHeight: 50,
        maxHeight: dfvHeight,
    };
    const inIframe = window.parent !== window;
    const belowMinRows = agData.length + df_viewer_config.pinned_rows.length < 10;
    const shortMode = belowMinRows &&
        ((_b = df_viewer_config === null || df_viewer_config === void 0 ? void 0 : df_viewer_config.extra_grid_config) === null || _b === void 0 ? void 0 : _b.rowHeight) === undefined;
    const layoutType = shortMode ? 'autoHeight' : 'normal';
    const applicableStyle = shortMode ? shortDivStyle : regularDivStyle;
    console.log('shortMode', shortMode, dfvHeight, inIframe);
    return (react_1.default.createElement("div", { className: `df-viewer  ${shortMode ? 'short-mode' : 'regular-mode'} ${inIframe ? 'in-iframe' : ''}` },
        react_1.default.createElement("div", { style: applicableStyle, className: "theme-hanger ag-theme-alpine-dark " },
            react_1.default.createElement(ag_grid_react_1.AgGridReact, { ref: gridRef, domLayout: layoutType, defaultColDef: defaultColDef, gridOptions: gridOptions, rowData: agData, pinnedTopRowData: topRowData, columnDefs: lodash_1.default.cloneDeep(styledColumns), autoSizeStrategy: getAutoSize() }))));
}
exports.DFViewer = DFViewer;
function DFViewerEx() {
    const [activeCol, setActiveCol] = (0, react_1.useState)('tripduration');
    return (react_1.default.createElement(DFViewer, { df_data: staticData_1.tableDf.data, df_viewer_config: staticData_1.tableDf.dfviewer_config, summary_stats_data: staticData_1.summaryDfForTableDf, activeCol: activeCol, setActiveCol: setActiveCol }));
}
exports.DFViewerEx = DFViewerEx;
//# sourceMappingURL=DFViewer.js.map